/*
 Copyright 2011 Anton Kraievoy akraievoy@gmail.com
 This file is part of Holonet.

 Holonet is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Holonet is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Holonet. If not, see <http://www.gnu.org/licenses/>.
 */

package algores.holonet.core.api;

import algores.holonet.core.Env;
import algores.holonet.core.EnvMappings;
import algores.holonet.core.Network;
import algores.holonet.core.Node;

public abstract class LocalServiceBase implements LocalService {
  protected Node owner;

  public void init(Node ownerNode) {
    this.owner = ownerNode;
  }

  public Node getOwner() {
    return owner;
  }
  
  protected Network getNetwork() {
    return owner.getNetwork();
  }

  protected Env getEnv() {
    return getNetwork().getEnv();
  }

  protected EnvMappings getMappings() {
    return getEnv().getMappings();
  }
}
